class Character {
    constructor() {

    }

    set name(name) {this._name = name};
    get name() {return this._name};

    set ap(ap) {this._ap = ap};
    get ap() {return this._ap};

    set hp(hp) {this._hp = hp};
    get hp() {return this._hp};

    set x(x) {this._x = x};
    get x() {return this._x};

    set y(y) {this._y = y};
    get y() {return this._y};

    set direction(direction) {this._direction = direction};
    get direction() {return this._direction};

    set bgposX(bgposX) {this._bgposX = bgposX}
    get bgposX() {return this._bgposX}

    set bgposY(bgposY) {this._bgposY = bgposY}
    get bgposY() {return this._bgposY}
}

class BraveMan extends Character {
    constructor() {
        super();

        this.name = "ゆうしゃ";
        this.ap = 2;
        this.hp = 20;

        this.x = 0;
        this.y = 0;

        this.bgposX = 0;
        this.bgposY = -2 * 32;

        this.direction = 'south';
    }

    /**
     * 方向を変えた時にはキャラクターの向きも変える
     * @param directoin
     */
    set direction(directoin) {
        this._direction = directoin;
        switch (this._direction) {
            case 'north':
                this.bgposY = 0;
                break;
            case 'east':
                this.bgposY = -1 * 32;
                break;
            case 'south':
                this.bgposY = -2 * 32;
                break;
            case 'west':
                this.bgposY = -3 * 32;
                break;
        }
        this.draw(); // 再描画する
    }
    get direction() {return this._direction};

    /**
     * 勇者を配置する
     */
    initialize() {
        const characterHTML = "<div class=\"field-character\" id=\"brave-man\"></div>";
        const fieldArea = document.getElementById("fieldArea");
        fieldArea.innerHTML += characterHTML;
        this.draw();
    }

    draw() {
        const braveman = document.getElementById("brave-man");
        if (typeof braveman !== 'undefined' && braveman !== null) {
            braveman.style.top = this.y * 32 + 'px';
            braveman.style.left = this.x * 32 + 'px';
            braveman.style.backgroundPositionX = this.bgposX + 'px';
            braveman.style.backgroundPositionY = this.bgposY + 'px';
        }
    }
}