class FieldTile {

    constructor() {

    }

    set name(name) {this._name = name};
    get name() {return this._name};

    set iswalk(iswalk) {this._iswalk = iswalk}
    get iswalk() {return this._iswalk}

    set bgposX(bgposX) {this._bgposX = bgposX}
    get bgposX() {return this._bgposX}

    set bgposY(bgposY) {this._bgposY = bgposY}
    get bgposY() {return this._bgposY}


    /**
     * フィールドデータ情報に基づいてフィールドを描画する
     */
    static initializeMap() {
        /*
         * 2回呼ばれないように
         */
        if (FieldTile.initialized === true) {
            console.log("already initialized");
            return;
        }
        FieldTile.initialized = true;

        /*
         * マップの描画
         */
        for (let line in FieldTile.fieldMap) {
            for (let column in FieldTile.fieldMap[line]) {
                const fieldKind = FieldTile.fieldMap[line][column];
                const tileObj = FieldTile.fieldData[fieldKind];
                const tileId = "tile" + line + '-' + column;
                const tileHTML = "<div class=\"field-tile\" id=\"" + tileId +  "\"></div>";
                const fieldArea = document.getElementById("fieldArea");
                fieldArea.innerHTML += tileHTML;
                const tileElement = document.getElementById(tileId);
                tileElement.style.top = line * 32 + 'px';
                tileElement.style.left = column * 32 + 'px';
                tileElement.style.backgroundPositionX = tileObj.bgposX + 'px';
                tileElement.style.backgroundPositionY = tileObj.bgposY + 'px';
            }
        }

        /*
         * 勇者を配置
         */
        yusha.initialize();
    }
}

class FieldGrass extends FieldTile {
    constructor() {
        super();

        this.name = "草原";
        this.iswalk = true;

        this.bgposX = 0;
        this.bgposY = 0;
    }
}

class FieldRiver extends FieldTile {
    constructor() {
        super();

        this.name = "川";
        this.iswalk = false;

        this.bgposX = -5 * 32;
        this.bgposY = 0;
    }
}

class FieldBridge extends FieldTile {
    constructor() {
        super();

        this.name= "橋";
        this.iswalk = true;

        this.bgposX = -9 * 32;
        this.bgposY = -32;
    }
}

class FieldPortal extends FieldTile {
    constructor() {
        super();

        this.name = "出口";
        this.iswalk = true;

        this.bgposX = -9 * 32;
        this.bgposY = 0;
    }
}

/*
 * 残念ながらクラス変数のstaticな初期化はクラス定義内では
 * できないので，定義の外でやる．
 */

// 0=草原, 1=川, 2=橋, 3=出口
FieldTile.fieldData = [
    new FieldGrass(),   // 草原
    new FieldRiver(),   // 川
    new FieldBridge(),  // 橋
    new FieldPortal()   // 出口
];

FieldTile.fieldMap = [
    [0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
    [0, 0, 0, 0, 0, 0, 1, 1, 0, 0],
    [0, 0, 0, 0, 0, 0, 2, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
    [0, 0, 0, 1, 1, 1, 1, 0, 0, 0],
    [0, 0, 0, 1, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 2, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 1, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 1, 0, 0, 0, 3, 0, 0]
];

FieldTile.initialized = false;