
// 0=草原, 1=川, 2=橋, 3=出口
// var fieldData = ['草原', '川', '橋', '出口'];
var fieldData = [
    {"name": "草原", "iswalk": true},
    {"name": "川", "iswalk": false},
    {"name": "橋", "iswalk": true},
    {"name": "出口", "iswalk": true}
];
// fieldData[0] => {"name": "草原", "iswalk": true}
// fieldData[1] => {"name": "川", "iswalk": false}
// fiedlData[1].name => 川, fieldData[1].iswalk => false

var monsters = [
    {"name": "スライム", "atack": 1, "hp": 2},
    {"name": "おおねずみ", "atack": 1, "hp": 4},
    {"name": "ゆうれい", "atack": 5, "hp": 10},
    {"name": "ドラゴン", "atack": 10, "hp": 50}
];

var yusha = [
    {"name": "ゆうしゃ", "atack": 2, "hp": 20}
];

var field00 = [
    [0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 1, 0, 0],
    [0, 0, 0, 0, 0, 0, 1, 1, 0, 0],
    [0, 0, 0, 0, 0, 0, 2, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
    [0, 0, 0, 1, 1, 1, 1, 0, 0, 0],
    [0, 0, 0, 1, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 2, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 1, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 1, 0, 0, 0, 3, 0, 0]
];

var yushaCurrent = [0, 0]; // 勇者の x, y 座標

/**
 * （Javadocとか何とかdocとかいう形式のコメント．
 * ここからHTMLドキュメントを自動生成するツールがあったりします）
 *
 * 指定されたパーセント（率）でサイコロをふって
 * 当たれば true を返す
 *
 * @param percent 百分率
 */
function isPercent(percent) {
    var r = Math.random() * 100; // 0 〜 100 未満の少数を取得
    var ret = false;

    // r が percent 指定より小さい場合は ret を true にする
    if (r <= percent) {
        ret = true;
    }

    return ret;
}

/**
 * 0からmonsters配列の要素の数までの整数を生成する
 */
function selectMonster() {
    var numMonsters = monsters.length; // 配列のlengthまたはsizeで要素数が分かる
    /*
     * Javascript以外でも使える方式
     * * 乱数関数が，0 - 1 未満の小数を出力する場合
     * * でてきた値を numMonsters 倍して整数に切り捨て = 0 - numMonster * 未満までの整数
     * * (これを numMonsters でわった余りを出す)
     */
    var numSelected = Math.floor(Math.random() * numMonsters);
    return numSelected;
}

function fortune(direction){

    var yushaCurrentX = yushaCurrent[0];
    var yushaCurrentY = yushaCurrent[1];

    if (direction == 'west') {
        yushaCurrentX--;
    } else if (direction == 'east') {
        yushaCurrentX++;
    } else if (direction == 'north') {
        yushaCurrentY--;
    } else if (direction == 'south') {
        yushaCurrentY++;
    }

    var currentFieldData = "フィールドからはみ出してます";
    // フィールドからはみ出してない？
    if (0 <= yushaCurrentX && (yushaCurrentX <= 9) && (yushaCurrentY >= 0) && (yushaCurrentY <= 9)) {
        // はみ出してない！

        var currentFieldY = field00[yushaCurrentY][yushaCurrentX];
        //          var currentFieldX = currentFieldY[yushaCurrentX];
        currentFieldData = fieldData[currentFieldY].name;

        if (fieldData[currentFieldY].iswalk == false) {
            // ここは通れない
            currentFieldData += "（ここは通れません）";
        } else {
            // 通れた時だけ勇者の現在位置を更新
            yushaCurrent[0] = yushaCurrentX;
            yushaCurrent[1] = yushaCurrentY;
            // モンスターの出現チェック
            if (isPercent(20)) {
                var selected = selectMonster();
                currentFieldData += ":" + monsters[selected].name + "があらわれた！";
            }
        }
    }

    var output = document.getElementById("fortuneItem");
    output.innerHTML = currentFieldData;
    output.className = "happy";
}
