/*
 * ドット絵はこちらからお借りしています　
 * http://www.ob2.aitai.ne.jp/~owl/material/dot.html
 */
const monsters = [
    // 作成中
];

const yusha = new BraveMan();

/**
 * （Javadocとか何とかdocとかいう形式のコメント．
 * ここからHTMLドキュメントを自動生成するツールがあったりします）
 *
 * 指定されたパーセント（率）でサイコロをふって
 * 当たれば true を返す
 *
 * @param percent 百分率
 */
const isPercent = (percent) => {
    var r = Math.random() * 100; // 0 〜 100 未満の少数を取得
    var ret = false;

    // r が percent 指定より小さい場合は ret を true にする
    if (r <= percent) {
        ret = true;
    }

    return ret;
};

/**
 * 0からmonsters配列の要素の数までの整数を生成する
 */
const selectMonster = () => {
    var numMonsters = monsters.length; // 配列のlengthまたはsizeで要素数が分かる
    /*
     * Javascript以外でも使える方式
     * * 乱数関数が，0 - 1 未満の小数を出力する場合
     * * でてきた値を numMonsters 倍して整数に切り捨て = 0 - numMonster * 未満までの整数
     * * (これを numMonsters でわった余りを出す)
     */
    var numSelected = Math.floor(Math.random() * numMonsters);
    return numSelected;
};

const fortune = (direction) => {

    let yushaTemporaryX = yusha.x;
    let yushaTemporaryY = yusha.y;

    console.log("yusha.x=" + yusha.x);
    console.log("yusha.y=" + yusha.y);
    console.log("direction=" + direction + ", yusha=" + yusha.direction);
    if (direction !== yusha.direction) {
        yusha.direction = direction;
    } else {
        switch (direction) {
            case 'west':
                yushaTemporaryX--;
                break;
            case 'east':
                yushaTemporaryX++;
                break;
            case 'north':
                yushaTemporaryY--;
                break;
            case 'south':
                yushaTemporaryY++;
                break;
        }
    }

    let message = "フィールドからはみ出してます";
    // フィールドからはみ出してない？
    if (0 <= yushaTemporaryX && (yushaTemporaryX <= 9) && (yushaTemporaryY >= 0) && (yushaTemporaryY <= 9)) {
        // はみ出してない！

        const tileNumber = FieldTile.fieldMap[yushaTemporaryY][yushaTemporaryX];
        const tileObject = FieldTile.fieldData[tileNumber];

        // 移動先の場所の名前を取得する
        message = tileObject.name;

        if (tileObject.iswalk == false) {
                // ここは通れない
            message += "（ここは通れません）";
        } else {
            // 通れた時だけ勇者の現在位置を更新
            yusha.x = yushaTemporaryX;
            yusha.y = yushaTemporaryY;
            // 勇者の位置を変更
            yusha.draw();

            // モンスターの出現チェック
            // if (isPercent(20)) {
            //     var selected = selectMonster();
            //     message += ":" + monsters[selected].name + "があらわれた！";
            // }
        }
    }

    var output = document.getElementById("fortuneItem");
    output.innerHTML = message;
    output.className = "happy";
};


if( window.addEventListener )
{
    window.addEventListener( 'load', FieldTile.initializeMap, false );
}
else if( window.attachEvent )
{
    window.attachEvent( 'onload', FieldTile.initializeMap );
}
else
{
    window.onload = FieldTile.initializeMap;
}

/*
 * 読み込み時に自動実行される関数の書き方
 */
// (function () {
//     console.log("Start!");
//     setTimeout(function() {initializeMap();}, 0);
// })();